package org.dive4elements.river.model;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.GeneratedValue;
import javax.persistence.Column;
import javax.persistence.SequenceGenerator;
import javax.persistence.GenerationType;
import javax.persistence.OneToOne;
import javax.persistence.JoinColumn;

@Entity
@Table(name = "named_main_values")
public class NamedMainValue
implements   Serializable
{
    private Integer       id;
    private String        name;
    private MainValueType type;

    public NamedMainValue() {
    }

    public NamedMainValue(String name, MainValueType type) {
        this.name = name;
        this.type = type;
    }

    @Id
    @SequenceGenerator(
        name           = "SEQUENCE_NAMED_MAIN_VALUES_ID_SEQ",
        sequenceName   = "NAMED_MAIN_VALUES_ID_SEQ",
        allocationSize = 1)
    @GeneratedValue(
        strategy  = GenerationType.SEQUENCE,
        generator = "SEQUENCE_NAMED_MAIN_VALUES_ID_SEQ")
    @Column(name = "id")
    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    @Column(name = "name")
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @OneToOne
    @JoinColumn(name = "type_id" )
    public MainValueType getType() {
        return type;
    }

    public void setType(MainValueType type) {
        this.type = type;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
